# language: ru

Функционал: Создание пользователей
    Как разработчик
    Я хочу иметь создать пользователей ИБ, в т.ч. и первого пользователя-администратора
    Чтобы выполнять коллективную разработку проекта 1С

Сценарий: Подготовка ИБ
    Допустим Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог

    Допустим Я создаю каталог "build/out" в рабочем каталоге
    И Я копирую каталог "cf" из каталога "tests/fixtures" проекта в рабочий каталог

    И Я установил рабочий каталог как текущий каталог
    Когда Я сохраняю каталог проекта в контекст

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --src ./cf --nocacheuse --language ru"
    И Код возврата команды "oscript" равен 0
    И Я очищаю параметры команды "oscript" в контексте

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf <КаталогПроекта>/epf/СоздатьПользователей СоздатьПользователей.epf --nocacheuse --language ru"
    И Код возврата команды "oscript" равен 0

Сценарий: Создание первого пользователя-администратора

    И Я очищаю параметры команды "oscript" в контексте

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os run" для команды "oscript"
    И Я добавляю параметр "--command" для команды "oscript"
    И Я добавляю параметр "СоздатьАдминистратора;Имя=Администратор;ЗавершитьРаботуСистемы" для команды "oscript"
    И Я добавляю параметр "--execute СоздатьПользователей.epf" для команды "oscript"
    # И Я добавляю параметр "--execute $runnerRoot\epf\СоздатьПользователей.epf" для команды "oscript"
    И Я добавляю параметр " --ibconnection /Fbuild/ib" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"
    Когда Я выполняю команду "oscript"

    # И Я сообщаю вывод команды "oscript"

    Тогда Вывод команды "oscript" содержит
        | ИНФОРМАЦИЯ - Выполняю команду/действие в режиме 1С:Предприятие |
        | Информация: Пользователь-администратор с именем Администратор создан! |
        | ИНФОРМАЦИЯ - Выполнение команды/действия в режиме 1С:Предприятие завершено. |
    Тогда Вывод команды "oscript" не содержит
        | Ошибка: Неудача при обработке параметров запуска |
    И Код возврата команды "oscript" равен 0

Сценарий: Неудача входа без пользователя, если пользователи существуют

    И Я очищаю параметры команды "oscript" в контексте

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os run" для команды "oscript"
    И Я добавляю параметр "--command" для команды "oscript"
    И Я добавляю параметр "СоздатьАдминистратора;Имя=Администратор;ЗавершитьРаботуСистемы" для команды "oscript"
    И Я добавляю параметр "--execute СоздатьПользователей.epf" для команды "oscript"
    И Я добавляю параметр " --ibconnection /Fbuild/ib" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"
    Когда Я выполняю команду "oscript"

    Тогда Вывод команды "oscript" содержит
        | ИНФОРМАЦИЯ - Выполняю команду/действие в режиме 1С:Предприятие |
        | Пользователь ИБ не идентифицирован |
        | ИНФОРМАЦИЯ - Выполнение команды/действия в режиме 1С:Предприятие завершено. |
    Тогда Вывод команды "oscript" не содержит
        | Ошибка: Неудача при обработке параметров запуска |
    И Код возврата команды "oscript" равен 0

Сценарий: Неудача создания первого пользователя-администратора, если пользователи существуют

    И Я очищаю параметры команды "oscript" в контексте

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os run" для команды "oscript"
    И Я добавляю параметр "--command" для команды "oscript"
    И Я добавляю параметр "СоздатьАдминистратора;Имя=Администратор;ЗавершитьРаботуСистемы" для команды "oscript"
    И Я добавляю параметр "--execute СоздатьПользователей.epf" для команды "oscript"
    И Я добавляю параметр " --ibconnection /Fbuild/ib" для команды "oscript"
    И Я добавляю параметр " --db-user Администратор" для команды "oscript"
    И Я добавляю параметр "--language ru" для команды "oscript"
    Когда Я выполняю команду "oscript"

    Тогда Вывод команды "oscript" содержит
        | ИНФОРМАЦИЯ - Выполняю команду/действие в режиме 1С:Предприятие |
        | Ошибка: Уже существуют пользователь. Пользователь-администратор не создан! |
        | ИНФОРМАЦИЯ - Выполнение команды/действия в режиме 1С:Предприятие завершено. |
    Тогда Вывод команды "oscript" не содержит
        | Ошибка: Неудача при обработке параметров запуска |
    И Код возврата команды "oscript" равен 0
