# language: ru

Функционал: Загрузка расширений конфигурации
    Как разработчик
    Я хочу иметь возможность загрузить расширения конфигурации из файла
    Чтобы выполнять коллективную разработку проекта 1С

Контекст:
    Допустим я подготовил репозиторий и рабочий каталог проекта
    И я подготовил рабочую базу проекта "./build/ib" по умолчанию
    Допустим Я копирую файл "Extension1.cfe" из каталога "tests/fixtures" проекта в рабочий каталог
    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Загрузка одного расширения из файла с обновлением БД
    
    Дано Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os loadext --file Extension1.cfe --extension Расширение1 --updatedb --ibconnection /F./build/ib --language ru"
    И Я показываю вывод команды
    Тогда Код возврата равен 0
    И Я очищаю параметры команды "oscript" в контексте

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os unloadext ./РасширениеНовое1.cfe Расширение1 --ibconnection /F./build/ib --language ru"
    И Я показываю вывод команды
    И Файл "./РасширениеНовое1.cfe" существует
    Тогда Код возврата равен 0

Сценарий: Загрузка одного расширения из файла без обновления БД
    
    Дано Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os loadext --file Extension1.cfe --extension Расширение1 --ibconnection /F./build/ib --language ru"
    И Я показываю вывод команды
    Тогда Код возврата равен 0
    И Я очищаю параметры команды "oscript" в контексте
    
    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os unloadext ./РасширениеНовое1.cfe Расширение1 --ibconnection /F./build/ib --language ru"
    И Я показываю вывод команды
    И Файл "./РасширениеНовое1.cfe" существует
    Тогда Код возврата равен 0

Сценарий: Загрузка одного расширения из файла с обновлением БД без указания имени расширения
    
    Дано Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os loadext --file Extension1.cfe --updatedb --ibconnection /F./build/ib --language ru"
    И Я показываю вывод команды
    Тогда Вывод команды "oscript" содержит
        | Не задано имя расширения в ключе --extension |
    Тогда Код возврата равен 1
    И Я очищаю параметры команды "oscript" в контексте

# TODO Сценарий: Разборка нескольких расширений с явно заданной базой
