# language: ru

Функционал: Запуск Конфигуратора 1С
    Как разработчик
    Я хочу иметь возможность запускать Конфигуратор интерактивно и автоматически из командной строки
    Чтобы выполнять коллективную разработку проекта 1С

Сценарий: Подготовка ИБ
    # Допустим  я включаю отладку лога с именем "oscript.app.vanessa-runner"
    # Допустим  я включаю отладку лога с именем "oscript.lib.v8runner"
    # И Я сохраняю значение "DEBUG" в переменную окружения "LOGOS_LEVEL"
    # Допустим  я включаю отладку лога с именем "bdd"
    Допустим Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог

    Допустим Я создаю каталог "build/out" в рабочем каталоге
    И Я копирую каталог "cf" из каталога "tests/fixtures" проекта в рабочий каталог

    И Я установил рабочий каталог как текущий каталог
    Когда Я сохраняю каталог проекта в контекст

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --src ./cf --nocacheuse --language ru"
    Тогда Вывод команды "oscript" содержит "Обновление конфигурации базы данных успешно завершено"
    # Тогда Вывод команды "oscript" содержит "Database configuration successfully updated"

    И Код возврата команды "oscript" равен 0

    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Передача параметра --additional - Проверка установленных расширений

    Когда Я выполняю команду "oscript" с параметрами '<КаталогПроекта>/src/main.os designer --additional  "/DumpDBCfgList -AllExtensions" --ibconnection /Fbuild/ib --language ru '
    И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит
        | Работа Конфигуратора завершена |
    И Код возврата команды "oscript" равен 0

# эти 2 сценария нужно выполнить последними, т.к. они блокируют конфигуратор

Сценарий: Интерактивный запуск Конфигуратора

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os designer --ibconnection /Fbuild/ib --no-wait --language ru"
    # И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит
        | ИНФОРМАЦИЯ - Выполняю команду Конфигуратора |
        # | ИНФОРМАЦИЯ - Информации об ошибке нет |
        | ИНФОРМАЦИЯ - Работа Конфигуратора завершена |
    И Код возврата команды "oscript" равен 0

Сценарий: Блокировка автоматического запуска Конфигуратора, т.к. ИБ из предыдущего сценария уже залочена Конфигуратором интерактивного запуска

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os designer --ibconnection /Fbuild/ib --language ru"
    # И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит
        # | ПРЕДУПРЕЖДЕНИЕ - Не удалось прочитать файл информации |
        | ОШИБКА - Запрещено использование окон. Передан ключ DisableStartupDialogs |
    И Код возврата команды "oscript" равен 1
