# language: ru

Функционал: Объединение конфигураций
    Как разработчик
    Я хочу объединять cf-файл с конфигурацией базы
    Чтобы выполнять коллективную разработку проекта 1С

Контекст: Подготовка репозитория и рабочего каталога проекта 1С

    Допустим Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я инициализирую репозиторий git в рабочем каталоге
    Допустим Я создаю каталог "build/out" в рабочем каталоге
    И Я копирую каталог "cf" из каталога "tests/fixtures" проекта в рабочий каталог
    И Я копирую файл "MergeSettingsКонфигурация-cf-to-empty.xml" из каталога "tests/fixtures" проекта в рабочий каталог

    И Я установил рабочий каталог как текущий каталог
    И Я сохраняю каталог проекта в контекст
    И Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --src ./cf --nocacheuse --language ru"
    И Я очищаю параметры команды "oscript" в контексте
    И Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os init-dev --nocacheuse --ibconnection /F./build/ib-work --language ru"
    И Я очищаю параметры команды "oscript" в контексте

    Допустим Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os unload ./build/1Cv8.cf --ibconnection /F./build/ib --language ru"
    И Код возврата команды "oscript" равен 0
    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Объединение cf-файла с конфигурацией

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os merge -s ./build/1Cv8.cf --merge-settings MergeSettingsКонфигурация-cf-to-empty.xml --ibconnection /F./build/ib-work --language ru"
    Тогда я вижу в консоли вывод "Успешно завершено объединение конфигураций"
    И Код возврата команды "oscript" равен 0

Сценарий: Объединение cf-файла с конфигурацией с поставкой на поддержку

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os merge -s ./build/1Cv8.cf --enable-support --merge-settings MergeSettingsКонфигурация-cf-to-empty.xml --ibconnection /F./build/ib-work --language ru"
    Тогда я вижу в консоли вывод "Возможность объединения с постановкой на поддержку отсутствует"
    И Код возврата команды "oscript" равен 1

Сценарий: Объединение cf-файла без указания файла настроек

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os merge -s ./build/1Cv8.cf --ibconnection /F./build/ib-work --language ru"
    И Код возврата команды "oscript" равен 1
    Тогда я вижу в консоли вывод "Необходимо задать к файлу с настройками объединения конфигураций"
