# language: ru

Функциональность: Выполнение команды продукта

Как разработчик
Я хочу иметь возможность выполнять команды продукта
Чтобы выполнять коллективную разработку приложения для OneScript

Контекст:
    Допустим Я очищаю параметры команды "oscript" в контексте

Сценарий: Получение версии продукта
    Когда Я выполняю команду "oscript" с параметрами "src/main.os version"
    Тогда Я сообщаю вывод команды "oscript"
    И Вывод команды "oscript" содержит "."
    И Вывод команды "oscript" не содержит "vanessa-runner v"
    И Код возврата команды "oscript" равен 0

Сценарий: Получение помощи продукта
    Когда Я выполняю команду "oscript" с параметрами "src/main.os help"
    И Вывод команды "oscript" содержит "vanessa-runner v"
    И Вывод команды "oscript" содержит "Вывод справки по параметрам"
    И Вывод команды "oscript" содержит "Вывод версии приложения"
    И Код возврата команды "oscript" равен 0

Сценарий: Вызов исполняемого файла без параметров
    Когда Я выполняю команду "oscript" с параметрами "src/main.os"
    Тогда Вывод команды "oscript" содержит "vanessa-runner v"
    И Вывод команды "oscript" не содержит "ОШИБКА - Некорректные аргументы командной строки"
    И Вывод команды "oscript" содержит "Вывод справки по параметрам"
    И Код возврата команды "oscript" равен 0

Сценарий: Вызов приложения с выводом отладки в отдельный файл

    Дано Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я установил рабочий каталог как текущий каталог
    # отладку логов включать нельзя, т.к. сценарий упадет
    # И я включаю полную отладку логов пакетов OneScript

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os version --debuglogfile 11/debug.log"
    Тогда Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит "."
    И я показываю текст файла "11/debug.log"
    И Файл "11/debug.log" содержит "ОТЛАДКА - Подключил вывод отладочного лога в отдельный файл 11/debug.log"
    И Вывод команды "oscript" не содержит "ОТЛАДКА - Подключил вывод отладочного лога в отдельный файл debug.log"
    И Код возврата команды "oscript" равен 0

Сценарий: Вызов приложения с выводом отладки во временный файл

    Дано Я создаю временный каталог и сохраняю его в контекст
    И Я устанавливаю временный каталог как рабочий каталог
    И Я установил рабочий каталог как текущий каталог
    # отладку логов включать нельзя, т.к. сценарий упадет
    # И я включаю полную отладку логов пакетов OneScript

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os version --debuglog"
    Тогда Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит "."
    # И я показываю текст файла "debug.log"
    # И Файл "debug.log" содержит "ОТЛАДКА - Подключил вывод отладочного лога в отдельный файл debug.log"
    И Вывод команды "oscript" не содержит "ОТЛАДКА - Подключил вывод отладочного лога в отдельный файл debug.log"
    И Код возврата команды "oscript" равен 0

# TODO Сценарий: Вызов приложения с предварительно включенной отладкой
# проверить вывод отладочной инфы
    # И я включаю отладку лога с именем "oscript.app.vanessa-runner"
