# language: ru

Функционал: Сборка внешних обработок
    Как разработчик
    Я хочу иметь возможность собирать внешние обработки 1С из исходников
    Чтобы выполнять коллективную разработку проекта 1С

Контекст:
    Допустим я подготовил репозиторий и рабочий каталог проекта

    И Я копирую каталог "fixture-epf" из каталога "tests/fixtures" проекта в подкаталог "build/out" рабочего каталога
    И Я копирую файл "file.txt" из каталога "tests/fixtures" проекта в подкаталог "build/out" рабочего каталога

    Допустим файл "fixture.epf" не существует
    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Сборка каталога внешних обработок

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf build/out/fixture-epf . --language ru"
    И Вывод команды "oscript" содержит "Собирали: fixture изменен"
    Тогда Код возврата команды "oscript" равен 0
    И файл "Тест1.epf" существует
    И файл "file.txt" не существует

Сценарий: Сборка внешней обработки в отдельном каталоге

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf build/out/fixture-epf build/out --language ru"
    И Вывод команды "oscript" содержит "Собирали: fixture изменен"
    Тогда Код возврата команды "oscript" равен 0
    И файл "build/out/Тест1.epf" существует
    И файл "file.txt" не существует

Сценарий: Сборка внешней обработки с явным указанием каталога исходников обработки в отдельном каталоге

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf build/out/fixture-epf/fixture build/out --language ru"
    И Вывод команды "oscript" содержит "Собирали: fixture изменен"
    Тогда Код возврата команды "oscript" равен 0
    И файл "build/Тест1.epf" не существует
    И файл "build/out/Тест1.epf" существует
    И файл "file.txt" не существует

Сценарий: Сборка каталога внешних обработок в том же каталоге, где исходники

    Допустим Я установил подкаталог "build/out" рабочего каталога как текущий каталог
    И Я копирую файл "file.txt" из каталога "tests/fixtures" проекта в подкаталог "build/out" рабочего каталога
    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf fixture-epf fixture-epf --language ru"
    И Вывод команды "oscript" содержит "Собирали: fixture изменен"
    Тогда Код возврата команды "oscript" равен 0
    И файл "fixture-epf/fixture/Тест1.epf" не существует

Сценарий: Сборка внешней обработки в отдельном каталоге с явным указанием имени результирующего файла

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf build/out/fixture-epf build/out/extdp.epf --language ru"
    И Вывод команды "oscript" содержит "Собирали: fixture изменен"
    Тогда Код возврата команды "oscript" равен 0
    И файл "build/out/Тест1.epf" не существует
    И файл "build/out/extdp.epf" существует
    И файл "file.txt" не существует

Сценарий: Сборка внешней обработки с явным указанием исходников обработки в отдельном каталоге и имени результирующего файла

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os compileepf build/out/fixture-epf/fixture build/out/extdp.epf --language ru"
    И Вывод команды "oscript" содержит "Собирали: fixture изменен"
    Тогда Код возврата команды "oscript" равен 0
    И файл "build/Тест1.epf" не существует
    И файл "build/extdp.epf" не существует
    И файл "build/out/Тест1.epf" не существует
    И файл "build/out/extdp.epf" существует
    И файл "file.txt" не существует

# Сценарий: Сборка одной внешней обработки
#     Когда TODO

# Сценарий: Сборка одной внешней обработки с явно заданной базой
#     Когда TODO

# Сценарий: Сборка каталога внешних обработок с явно заданной базой
#     Когда TODO
