# language: ru

Функционал: Установка номера версии или сборки файлов конфигурации, расширений, внешних обработок, отчетов
	Как Разработчик/Инженер по тестированию
	Я Хочу иметь возможность автоматической\автоматизированной установки номеров версий или сборок файлов 1С
    Чтобы быстро выпускать новые релизы или собирать артефакты, отличающиеся номерами

Контекст:
    Допустим я подготовил репозиторий и рабочий каталог проекта
    И я подготовил рабочую базу проекта "./build/ib" по умолчанию

    И Я сохраняю значение "INFO" в переменную окружения "LOGOS_LEVEL"
    Дано Я очищаю параметры команды "oscript" в контексте

Сценарий: Изменение версии конфигурации, указан путь Configuration.xml для конфигурации

    # И Я сохраняю значение "DEBUG" в переменную окружения "LOGOS_LEVEL"
    Тогда файл "cf/Configuration.xml" содержит "<Version>1.0.0.0</Version>"

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os set-version" для команды "oscript"
    И Я добавляю параметр "--new-version 2.0.0.0" для команды "oscript"
    И Я добавляю параметр "--src cf/Configuration.xml" для команды "oscript"

    Когда Я выполняю команду "oscript"
    # И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит
    | Изменяю версию в исходниках конфигурации 1С на 2.0.0.0 |
    |     Старая версия 1.0.0.0 |

    И Код возврата команды "oscript" равен 0

    Тогда файл "cf/Configuration.xml" содержит "<Version>2.0.0.0</Version>"

Сценарий: Изменение версии конфигурации, указан путь Configuration.xml для расширения

    Дано Я копирую каталог "cfe" из каталога "tests/fixtures" проекта в рабочий каталог
    Тогда файл "cfe/Configuration.xml" содержит "<Version>1.1.0.0</Version>"

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os set-version" для команды "oscript"
    И Я добавляю параметр "--new-version 2.0.0.0" для команды "oscript"
    И Я добавляю параметр "--src cfe/Configuration.xml" для команды "oscript"

    Когда Я выполняю команду "oscript"
    Тогда Вывод команды "oscript" содержит
    | Изменяю версию в исходниках конфигурации 1С на 2.0.0.0 |
    |     Старая версия 1.1.0.0 |

    И Код возврата команды "oscript" равен 0

    Тогда файл "cfe/Configuration.xml" содержит "<Version>2.0.0.0</Version>"

Сценарий: Изменение версии конфигурации, указан каталог корня исходников конфигурации

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os set-version" для команды "oscript"
    И Я добавляю параметр "--new-version 2.0.0.0" для команды "oscript"
    И Я добавляю параметр "--src cf" для команды "oscript"

    Когда Я выполняю команду "oscript"
    # И Я сообщаю вывод команды "oscript"
    Тогда Вывод команды "oscript" содержит
    | Изменяю версию в исходниках конфигурации 1С на 2.0.0.0 |
    |     Старая версия 1.0.0.0 |

    И Код возврата команды "oscript" равен 0

    Тогда файл "cf/Configuration.xml" содержит "<Version>2.0.0.0</Version>"

Сценарий: Изменение версии конфигурации, указан каталог корня исходников расширения

    Дано Я копирую каталог "cfe" из каталога "tests/fixtures" проекта в рабочий каталог

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os set-version" для команды "oscript"
    И Я добавляю параметр "--new-version 2.0.0.0" для команды "oscript"
    И Я добавляю параметр "--src cfe" для команды "oscript"

    Когда Я выполняю команду "oscript"
    Тогда Вывод команды "oscript" содержит
    | Изменяю версию в исходниках конфигурации 1С на 2.0.0.0 |
    |     Старая версия 1.1.0.0 |

    И Код возврата команды "oscript" равен 0

    Тогда файл "cfe/Configuration.xml" содержит "<Version>2.0.0.0</Version>"

Сценарий: Изменение версии и конфигурации и расширения, указан каталог корня проекта

    Дано Я копирую каталог "cfe" из каталога "tests/fixtures" проекта в рабочий каталог

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os set-version" для команды "oscript"
    И Я добавляю параметр "--new-version 2.0.0.0" для команды "oscript"
    И Я добавляю параметр "--src ." для команды "oscript"

    Когда Я выполняю команду "oscript"
    Тогда Вывод команды "oscript" содержит
    | Изменяю версию в исходниках конфигурации 1С на 2.0.0.0 |
    |     Старая версия 1.0.0.0 |
    |     Старая версия 1.1.0.0 |

    И Код возврата команды "oscript" равен 0

    Тогда файл "cf/Configuration.xml" содержит "<Version>2.0.0.0</Version>"
    Тогда файл "cfe/Configuration.xml" содержит "<Version>2.0.0.0</Version>"

Сценарий: Изменение версии, если в файле не задана версия

    Дано Я копирую каталог "cfe_without_version" из каталога "tests/fixtures" проекта в рабочий каталог

    Когда Я добавляю параметр "<КаталогПроекта>/src/main.os set-version" для команды "oscript"
    И Я добавляю параметр "--new-version 2.0.0.0" для команды "oscript"
    И Я добавляю параметр "--src cfe_without_version" для команды "oscript"

    Когда Я выполняю команду "oscript"
    Тогда Вывод команды "oscript" содержит
    | Изменяю версию в исходниках конфигурации 1С на 2.0.0.0 |
    |     Старая версия  |

    И Код возврата команды "oscript" равен 0

    Тогда файл "cfe_without_version/Configuration.xml" содержит "<Version>2.0.0.0</Version>"
