///////////////////////////////////////////////////////////////////
//
// Служебный модуль с набором методов работы с командами приложения
//
// Структура модуля реализована в соответствии с рекомендациями 
// oscript-app-template (C) EvilBeaver
//
///////////////////////////////////////////////////////////////////

Процедура ЗарегистрироватьКоманду(Знач ИмяКоманды, Знач Парсер) Экспорт

	ОписаниеКоманды = Парсер.ОписаниеКоманды(ИмяКоманды, "     Вывод справки по параметрам.");
	Парсер.ДобавитьПозиционныйПараметрКоманды(ОписаниеКоманды, "Команда", "Имя команды, для которой выводится справка");
	Парсер.ДобавитьКоманду(ОписаниеКоманды);
	
КонецПроцедуры // ЗарегистрироватьКоманду

// Выполняет логику команды
// 
// Параметры:
//   ПараметрыКоманды - Соответствие - Соответствие ключей командной строки и их значений
//   ДополнительныеПараметры - Соответствие - дополнительные параметры (необязательно)
//
Функция ВыполнитьКоманду(Знач ПараметрыКоманды, Знач Неиспользуется = Неопределено) Экспорт

	Парсер = Новый ПарсерАргументовКоманднойСтроки;

	МенеджерКомандПриложения.ЗарегистрироватьКоманды(Парсер);

	Если ПараметрыКоманды["Команда"] = Неопределено Тогда

		ПоказатьВозможныеКоманды(Парсер);

	Иначе
		
		ПоказатьСправкуПоКоманде(Парсер, ПараметрыКоманды["Команда"]);

	КонецЕсли;

	Возврат МенеджерКомандПриложения.РезультатыКоманд().Успех;

КонецФункции // ВыполнитьКоманду

Процедура ПоказатьВозможныеКоманды(Знач Парсер)

	Парсер.ВывестиСправкуПоКомандам();

КонецПроцедуры // ПоказатьВозможныеКоманды

Процедура ПоказатьСправкуПоКоманде(Знач Парсер, Знач ИмяКоманды)

	Парсер.ВывестиСправкуПоКоманде(ИмяКоманды);

КонецПроцедуры // ПоказатьСправкуПоКоманде
